package com.kingfore.utils;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

public class DateUtils {
    public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    public static SimpleDateFormat sdfs = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");


    public static  Date getNewDate(Date dt){
        Date newDate;
        try {
            newDate= sdf.parse(sdf.format(dt));
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        return newDate;
    }

    /**
     * 生成每10分钟的整点时间戳
     *
     * @return
     */
    public static Timestamp getLatelyTenMinsTimeslot(){
        Timestamp ts;
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.MINUTE, (calendar.get(Calendar.MINUTE))/10*10);
        calendar.set(Calendar.SECOND,0);
        calendar.set(Calendar.MILLISECOND,000);
        Date late = calendar.getTime();
        ts =new Timestamp(late.getTime());//
        calendar.add(Calendar.MINUTE, -10);
        Date early = calendar.getTime();
//        ts =new Timestamp(early.getTime());
        return ts;
    }

    /**
     * 时间变更
     *
     * @return
     */
    public Timestamp getChangeTime(Timestamp ts,int hour){
        Date dt =new Date(ts.getTime());
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(dt);
        calendar.add(Calendar.HOUR, hour);
        Timestamp tsp = new Timestamp(calendar.getTime().getTime());
        return tsp;
    }

    /**
     * 字符串时间（yyyy-MM-dd HH:mm:ss）转时间戳（long）
     * @param strTime
     * @return long
     */
    public Long changeStringTimeToLong(String strTime) {

        Date date = null;
        try {
            date = sdf.parse(strTime);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return date.getTime();
    }

    /**
     * 字符串时间（yyyy-MM-dd HH:mm:ss）转时间戳（Timestamp）
     * @param strTime
     * @return Timestamp
     */
    public Timestamp changeStringTimeToTimeStamp(String strTime) {

        Timestamp ts = null;
        try {
            Date date = sdf.parse(strTime);
            ts= new Timestamp(date.getTime());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return ts;
    }

    /**
     * 获取整点数据
     * @return
     */
    public Date getCurrentTimeZERO(){
        //创建时间格式化
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //获取现在的时间
        Date date = new Date();
        //处理时间
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        //需要获取的时间(前n天减n，后n天加n)
        int day = 0;
        cal.add(Calendar.DAY_OF_MONTH, day);
        //获取处理结果时间戳
        long nowTime =cal.getTimeInMillis();
        //处理时间(00:00:00)
        long todayStartTime = nowTime - (nowTime + TimeZone.getDefault().getRawOffset())% (1000*60);
        //格式化时间戳
        String str = sdf.format(todayStartTime);


        //打印
        System.err.println(str);
        //对堆内存中的强引用进行释放内存（等待GC）
        sdf = null;
        date = null;

        Date newDate= new Date(todayStartTime);
        System.err.println(newDate);
        return newDate;
    }



    public static void main(String[] args) throws ParseException {
//        System.out.println(new DateUtils().getLatelyTenMinsTimeslot());

        for (int i=1;i<2;i++){
            String startTime = "2023-01-01 01:06:09";
            Date startDate = new DateUtils().sdf.parse(startTime);
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(startDate);
            calendar.add(Calendar.SECOND, i);
            System.out.println(new DateUtils().sdf.format(calendar.getTime()));
        }

        new DateUtils().getCurrentTimeZERO();

    }
}
